
#include "Flex.h"

#define ENTRIES_NUM 7      

UINT32              evcode_base;

UINT32 siItem; // 


char bufR[0x50]; 
WCHAR bufM[0x11];

static const unsigned short fl[]={0x0046,0x006C,0x0065,0x0078,0x4FEE,0x6539,0}; //chang flex 
static const unsigned short ml[]={0x578B,0x53F7,0x4FEE,0x6539,0}; // chang model
static const unsigned short se[]={0x53D1,0x9001,0x4E8B,0x4EF6,0x4EE3,0x7801,0}; // send event code
static const unsigned short jie4[]={0x89E3,0x9501,0x7801,0x4FDD,0x5BC6,0x7801,0}; //SecurityUnlock
static const unsigned short baomi[]={0x4FDD,0x5BC6,0x7801,0x003A,0}; //"Security:"
static const unsigned short jiesuo[]={0x89E3,0x9501,0x7801,0x003A,0};//"Unlock:"
static const unsigned short pds[]={0x5907,0x4EFD,0x0050,0x0044,0x0053,0}; //backup PDS
static const unsigned short pdsc[]={0x0050,0x0044,0x0053,0x5907,0x4EFD,0x5B8C,0x6210,0xFF01,0}; // backup PDS
static const unsigned short ling[]={0x4FEE,0x590D,0x94C3,0x97F3,0x660E,0x7EC6,0}; // ToneDBKiller
static const unsigned short lingc[]={0x5B8C,0x6210,0x4FEE,0x590D,0x0020,0x0033,0x79D2,0x540E,0x91CD,0x542F,0xFF01,0}; // 3 seconds restart
static const unsigned short shortcut[]={0x5907,0x4EFD,0x002F,0x8FD8,0x539F,0x0020,0x5FEB,0x6377,0x952E,0}; //backup/restore shortcut
static const unsigned short shortcut1[]={0x5907,0x4EFD,0x5FEB,0x6377,0x952E,0}; //backup shortcut
static const unsigned short shortcut2[]={0x8FD8,0x539F,0x5FEB,0x6377,0x952E,0};	//restore shortcut
const char app_name[APP_NAME_LEN] = "Flex";


const EVENT_HANDLER_ENTRY_T any_state_handlers[] =
{
    { EV_TIMER_EXPIRED,       		     	 Timer },
    { EV_REVOKE_TOKEN,              APP_HandleUITokenRevoked },
    { STATE_HANDLERS_END,           NULL           },
};

const EVENT_HANDLER_ENTRY_T init_state_handlers[] =
{
   
    { EV_GRANT_TOKEN,               HandleUITokenGranted },
    { STATE_HANDLERS_END,           NULL           },
};

EVENT_HANDLER_ENTRY_T main_state_handlers[] =
{

    { EV_DIALOG_DONE,               HelloWorldExit },
    { EV_REQUEST_LIST_ITEMS,        HandleListReq  },
   
	  { EV_DONE,                      HelloWorldExit },
    { EV_SELECT,                        SelectItem },

    { STATE_HANDLERS_END,           NULL           },
};

 EVENT_HANDLER_ENTRY_T edit_state_handlers[] =
{
   
    { EV_GRANT_TOKEN,             	  HandleUITokenGranted },
    { EV_DATA,                               	 EditData  },
    { EV_DONE,                       		       EditOk  },
	  { EV_CANCEL,                 			 EditExit  },
    { STATE_HANDLERS_END,         			     	  NULL },
};

EVENT_HANDLER_ENTRY_T Staticlist_state_handlers[] =
{
   
    { EV_GRANT_TOKEN,             	  HandleUITokenGranted },
    
    { EV_DONE,                       		       EditExit },
	  { EV_SELECT,                 			 EditExit  },
	       { EV_CANCEL,                 			 EditExit  },
    { STATE_HANDLERS_END,         			     	  NULL },
};

EVENT_HANDLER_ENTRY_T RStaticlist_state_handlers[] =
{
   
    { EV_GRANT_TOKEN,             	  HandleUITokenGranted },
    
    { EV_DONE,                       		       EditExit },
	  { EV_SELECT,                 			 RSelectItem },
	       
    { STATE_HANDLERS_END,         			     	  NULL },
};

EVENT_HANDLER_ENTRY_T notice_state_handlers[] =
{
    
    { EV_GRANT_TOKEN,             	  HandleUITokenGranted },
    { EV_DIALOG_DONE,                           EditExit },
    { STATE_HANDLERS_END,         			     	  NULL },
};

static const STATE_HANDLERS_ENTRY_T state_handling_table[] =
{
    { HW_STATE_ANY,               
      NULL,                      
      NULL,                       
      any_state_handlers         
    },

    { HW_STATE_INIT,
      NULL,
      NULL,
      init_state_handlers
    },

    { HW_STATE_MAIN,
      MainStateEnter,
      StateExit,
      main_state_handlers
    },

    { HW_STATE_EDIT,
      EditStateEnter,
      StateExit,
      edit_state_handlers
    },
    
    { HW_STATE_Staticlist,
      StaticlistStateEnter,
      StateExit,
      Staticlist_state_handlers
    },
    
     { HW_STATE_RStaticlist,
      RStaticlistStateEnter,
      StateExit,
      RStaticlist_state_handlers
    },
    
    { HW_STATE_NOTICE,
      NoticeStateEnter,
      StateExit,
      notice_state_handlers
    }
    
};


UINT32 LdrInitEventHandlersTbl( EVENT_HANDLER_ENTRY_T *tbl,  UINT32 *base )
{
    UINT32          i=0;
    while( tbl[i].code!=STATE_HANDLERS_END )
    {
        if(tbl[i].code==STATE_HANDLERS_RESERVED)
        {
            tbl[i].code = (*base)++;
        }
        i++;
    }
    return *base;
}

UINT32 LdrFindEventHandlerTbl( EVENT_HANDLER_ENTRY_T *tbl,  EVENT_HANDLER_T *hfn )
{
    UINT32          i=0;
    while( tbl[i].code!=STATE_HANDLERS_END )
    {
        if(tbl[i].hfunc==hfn)
        {
            return tbl[i].code;
        }
        i++;
    }

    return 0;
}



UINT32 Register( char* file_uri,  char* param,  UINT32 reserve )
{
    UINT32 status = RESULT_OK;
	

    evcode_base = reserve;   
    
    LdrInitEventHandlersTbl( main_state_handlers, &evcode_base );



    status = APP_Register( &evcode_base,            //
                           1,                       // 
                           state_handling_table,    // 
                           HW_STATE_MAX,            // 
                           (void*)HelloWorldStart );   // 

	
		

    LdrStartApp(evcode_base);   

    return 1;   
}



UINT32 HelloWorldStart( EVENT_STACK_T *ev_st,  REG_ID_T reg_id,  UINT32 param2 )//void *reg_hdl )
{
    APP_HELLOWORLD_T     *app = NULL;
    UINT32 status = RESULT_OK;


 
    if( AFW_InquireRoutingStackByRegId( reg_id ) == RESULT_OK )
        return RESULT_FAIL; // 

    
    app = (APP_HELLOWORLD_T*)APP_InitAppData( (void *)APP_HandleEvent, // 
                                              sizeof(APP_HELLOWORLD_T), // 
                                              reg_id,
                                              0, 1,
                                              1,
                                              1, 1, 0 );
  
    status = InitResources();

    status = APP_Start( ev_st,
                        &app->apt,
                        HW_STATE_INIT, // 
                        state_handling_table,
                        HelloWorldExit,
                        app_name,
                        0 );
     
                      
                      

    return RESULT_OK;
}



UINT32 HelloWorldExit( EVENT_STACK_T *ev_st,  void *app )
{
    UINT32  status;
	APPLICATION_T           *papp = (APPLICATION_T*) app;
	
	APP_UtilUISDialogDelete(  &papp->dialog ); // 
 
    RemoveResources();

   
    status = APP_Exit( ev_st, app, 0 );

    
    LdrUnloadELF(&Lib); //

    return status;
}


UINT32 MainStateEnter( EVENT_STACK_T *ev_st,  void *app,  ENTER_STATE_TYPE_T type )
{
    APPLICATION_T           *papp = (APPLICATION_T*) app;
    SU_PORT_T               port = papp->port;
    UIS_DIALOG_T            dialog = 0;
    UINT32                  starting_num;

    
    
    if(type!=ENTER_STATE_ENTER) return RESULT_OK;    dialog = UIS_CreateList( &port,
                             0,
                             ENTRIES_NUM,
                             0,
                             &starting_num,
                             0,
                             2,
                             NULL,   //  
                             Resources[RES_LIST_CAPTION] );

   

    if(dialog == 0) return RESULT_FAIL;

    papp->dialog = dialog;


  
    SendListItems(ev_st, app, 1, starting_num);
	
	if (siItem != 0) // 
	{
		APP_UtilAddEvUISListChange( ev_st,
                                app,
                                0, // = 0
                                siItem,
                                7, //
                                FALSE,
                                2, // = 2
                                NULL,
                                NULL,
                                NULL );	
								
		UIS_HandleEvent( dialog,  ev_st );		
	}	

    return RESULT_OK;
}

UINT32 HandleUITokenGranted( EVENT_STACK_T *ev_st,  void *app )
{
    APPLICATION_T           *papp = (APPLICATION_T*) app;
    UINT32                  status;

   
    status = APP_HandleUITokenGranted( ev_st, app );

 
    if( (status == RESULT_OK) && (papp->token_status == 2) )
    {
        status = APP_UtilChangeState( HW_STATE_MAIN, ev_st, app );
    }
 
    return status;
}



UINT32 HandleListReq( EVENT_STACK_T *ev_st,  void *app )
{
    APPLICATION_T           *papp = (APPLICATION_T*) app;
    EVENT_T                 *event;
    UINT32                  start, num;

   
    if( !papp->focused ) return RESULT_OK;

  
    event = AFW_GetEv( ev_st );

	start = event->data.list_items_req.begin_idx;
	num = event->data.list_items_req.count;

   
    APP_ConsumeEv( ev_st, app );

    return SendListItems( ev_st, app, start, num );
}



UINT32 SendListItems( EVENT_STACK_T *ev_st,  void *app, UINT32 start, UINT32 num)
{
    APPLICATION_T           *papp = (APPLICATION_T*) app;
    LIST_ENTRY_T            *plist; // 
    UINT32                   i, index, status=RESULT_OK;
    

    if( num==0 ) return RESULT_FAIL; 

    plist = (LIST_ENTRY_T*) suAllocMem( sizeof(LIST_ENTRY_T)*num, NULL ); // malloc
    if( plist==NULL ) return RESULT_FAIL;

 

	for( index=0, i=start; (i<start+num) && (i<=ENTRIES_NUM); i++, index++)
	{
        plist[index].editable = false;          
        plist[index].content.static_entry.unk6 = 1;
    }

	
        UIS_MakeContentFromString( "Mq0", &(plist[0].content.static_entry.text),fl);
        UIS_MakeContentFromString( "Mq0", &(plist[1].content.static_entry.text),ml);
        UIS_MakeContentFromString( "Mq0", &(plist[2].content.static_entry.text),se);
        UIS_MakeContentFromString( "Mq0", &(plist[3].content.static_entry.text),jie4);
        UIS_MakeContentFromString( "Mq0", &(plist[4].content.static_entry.text),pds);
        UIS_MakeContentFromString( "Mq0", &(plist[5].content.static_entry.text),ling);
        UIS_MakeContentFromString( "Mq0", &(plist[6].content.static_entry.text),shortcut);
    status = APP_UtilAddEvUISListData( ev_st, app, 0,
                                       start, num,
                                       FBF_LEAVE,
                                       sizeof(LIST_ENTRY_T)*num,
                                       plist );
									   

    if( status!=RESULT_FAIL )
    {
       
        status = UIS_HandleEvent(papp->dialog, ev_st);
    }

    suFreeMem(plist);

    return status;

}


UINT32 InitResources( )
{

    UINT32                      status;
    WCHAR buf[32];


  
		status = DRM_CreateResource( &Resources[RES_LIST_CAPTION], RES_TYPE_STRING, (void*)(u_atou("edy.5d6d.com", buf)), (u_strlen((WCHAR*)(u_atou("edy.5d6d.com", buf)))+1)*sizeof(WCHAR) );
    if( status!=RESULT_OK ) return status;


		status = DRM_CreateResource( &Resources[RES_EDIT_CAPTION1], RES_TYPE_STRING, (void*)(u_atou("FLEX_changer", buf)), (u_strlen((WCHAR*)(u_atou("FLEX_changer", buf)))+1)*sizeof(WCHAR) );
    if( status!=RESULT_OK ) return status;
	
	  status = DRM_CreateResource( &Resources[RES_EDIT_CAPTION2], RES_TYPE_STRING, (void*)(u_atou("Model_changer", buf)), (u_strlen((WCHAR*)(u_atou("Model_changer", buf)))+1)*sizeof(WCHAR) );
   if( status!=RESULT_OK ) return status;
	
	   status = DRM_CreateResource( &Resources[RES_EDIT_CAPTION3], RES_TYPE_STRING, (void*)(u_atou("send_event", buf)), (u_strlen((WCHAR*)(u_atou("send_event", buf)))+1)*sizeof(WCHAR) );
     if( status!=RESULT_OK ) return status;
	
	
	   status = DRM_CreateResource( &Resources[RES_EDIT_CAPTION4], RES_TYPE_STRING, (void*)(u_atou("SecurityUnlock" ,buf)), (u_strlen((WCHAR*)(u_atou("SecurityUnlock",buf)))+1)*sizeof(WCHAR) );
    if( status!=RESULT_OK ) return status;
    	
    	status = DRM_CreateResource( &Resources[RES_EDIT_CAPTION5], RES_TYPE_STRING, (void*)(u_atou("PDSBackuper" ,buf)), (u_strlen((WCHAR*)(u_atou("PDSBackuper",buf)))+1)*sizeof(WCHAR) );
    if( status!=RESULT_OK ) return status;
    	
    	status = DRM_CreateResource( &Resources[RES_EDIT_CAPTION6], RES_TYPE_STRING, (void*)(u_atou("ToneDBKiller" ,buf)), (u_strlen((WCHAR*)(u_atou("ToneDBKiller",buf)))+1)*sizeof(WCHAR) );
    if( status!=RESULT_OK ) return status;
     
     status = DRM_CreateResource( &Resources[RES_EDIT_CAPTION7], RES_TYPE_STRING, (void*)(u_atou("ShortCut" ,buf)), (u_strlen((WCHAR*)(u_atou("ShortCut",buf)))+1)*sizeof(WCHAR) );
    if( status!=RESULT_OK ) return status;
    	
     return status;
}


UINT32 RemoveResources( )
{
    UINT32              status = RESULT_OK;
    UINT32              i;

    for(i=0;i<RES_MAX;i++)
    {
        status |= DRM_ClearResource( Resources[i] );
    }

    return status;

}

UINT32 SelectItem (EVENT_STACK_T *ev_st,  void *app )
{
     UINT32                  status;
	 EVENT_T     *event = AFW_GetEv(ev_st);
	
	siItem = event->data.index;
   if(siItem==4)
   	{
   		
   	 status = APP_UtilChangeState( HW_STATE_Staticlist, ev_st, app );
   	}
   	else if(siItem==5)
   		{
   			BackupToFile();
   			status =APP_UtilChangeState( HW_STATE_NOTICE, ev_st, app );
   			 //status = APP_UtilChangeState( HW_STATE_Staticlist, ev_st, app );
   		}
   		else if( siItem==6) 
   			{
   				ToneDBKiller();
   				 status = APP_UtilChangeState( HW_STATE_Staticlist, ev_st, app );
   			}
   else if( siItem==7) 
   			{
   				 status = APP_UtilChangeState( HW_STATE_RStaticlist, ev_st, app );
   			}
   		else
    status = APP_UtilChangeState( HW_STATE_EDIT, ev_st, app ); // ? ??

	APP_ConsumeEv( ev_st, app );
    return RESULT_OK;

}


UINT32 EditStateEnter( EVENT_STACK_T *ev_st,  void *app,  ENTER_STATE_TYPE_T type )
{
        APP_HELLOWORLD_T           *papp = (APP_HELLOWORLD_T*) app;
		RESOURCE_ID             CaptionEditor;
		
		
		switch (siItem)
		{
			case 1: //
				SEEM_FDI_OUTSIDE_SEEM_ACCESS_read(0x017F,1,(void*)bufR,0x50);  
				u_atou( bufR,  papp->msg );
				CaptionEditor = Resources[RES_EDIT_CAPTION1];
			break;
			
			case 2: //
				SEEM_FDI_OUTSIDE_SEEM_ACCESS_read(0x0117,1,(void*)bufM,0x22);  
				u_strcpy(papp->msg,bufM);
				CaptionEditor = Resources[RES_EDIT_CAPTION2];
			break;
			
			case 3: //
				u_atou("",  papp->msg );
				CaptionEditor = Resources[RES_EDIT_CAPTION3];
			break;
			
			
		}

        papp->apt.dialog = UIS_CreateCharacterEditor( &papp->port,
                                            papp->msg,
                                            2, // 
                                            0x20, // 3 
                                            FALSE,
                                            NULL,
                                            CaptionEditor
                                            );
        
		if(papp->apt.dialog == 0)
            return RESULT_FAIL;


        return RESULT_OK;
}

UINT32 StaticlistStateEnter( EVENT_STACK_T *ev_st,  void *app,  ENTER_STATE_TYPE_T type )
{
        APP_HELLOWORLD_T           *papp = (APP_HELLOWORLD_T*) app;
		// RESOURCE_ID             CaptionEditor=Resources[RES_EDIT_CAPTION4];
		// RESOURCE_ID             CaptionEditor1=Resources[RES_EDIT_CAPTION5];
		//LIST_ENTRY_T            *plist; // 
		  CONTENT_T   P;
		WCHAR *bao=suAllocMem( 20, NULL ),*jie=suAllocMem( 20, NULL );
		 
		
	
        
        
		switch (siItem)
		{
			
			
			case 4: // 
				/* plist = (LIST_ENTRY_T*) suAllocMem( sizeof(LIST_ENTRY_T)*4, NULL );
        plist[0].editable = FALSE;          
        plist[0].content.static_entry.unk6 = 1;
        plist[1].editable = FALSE;          
        plist[1].content.static_entry.unk6 = 1;
        plist[2].editable = FALSE;          
        plist[2].content.static_entry.unk6 = 1;
        plist[3].editable = FALSE;          
        plist[3].content.static_entry.unk6 = 1;
        
				UIS_MakeContentFromString( "Mq0", &(plist[0].content.static_entry.text),baomi);
				DL_DbSigNamGetSecurityCode(bao);
        UIS_MakeContentFromString( "Mq0", &(plist[1].content.static_entry.text),bao);
        UIS_MakeContentFromString( "Mq0", &(plist[2].content.static_entry.text),jiesuo);
        DL_DbSigNamGetUnlockCode(jie);
        UIS_MakeContentFromString( "Mq0", &(plist[3].content.static_entry.text),jie);*/
        
       // UIS_MakeContentFromString( "q0", &p1,baomi);
				DL_DbSigNamGetSecurityCode(bao);
        //UIS_MakeContentFromString( "q0", &p2,bao);
        //UIS_MakeContentFromString( "q0", &p3,jiesuo);
        DL_DbSigNamGetUnlockCode(jie);
        //UIS_MakeContentFromString( "q0", &p4,jie);
        
        UIS_MakeContentFromString( "s0Nq1Nq2Nq3Nq4",&P,Resources[RES_EDIT_CAPTION4],baomi,bao,jiesuo,jie);
        
        
        
			break;
			
			
			case 6:
				
				UIS_MakeContentFromString( "s0Nq1",&P,Resources[RES_EDIT_CAPTION6],lingc);
				APP_UtilStartTimer( 3000,  1,  app );
			break;
		}

       /* papp->apt.dialog = UIS_CreateStaticList( &papp->port,
                                                  0,
                                                  4,
                                                  0,
                                                  plist,
                                                  0,
                                                  2,
                                                  NULL,
                                                  CaptionEditor
                                                );  */
     papp->apt.dialog=UIS_CreateViewer (&papp->port,&P,NULL); 
     
                                                 
		if(papp->apt.dialog == 0)
            return RESULT_FAIL;

 // suFreeMem(plist);
  suFreeMem(bao);
  suFreeMem(jie);
        return RESULT_OK;
}


UINT32 EditData( EVENT_STACK_T *ev_st,  void *app )
{
    UINT32                  status = 0;
    EVENT_T      *event = AFW_GetEv(ev_st);
	  char *bufR3;
	  UINT8 S=0;
  
	//UINT32 written;
	//FILE_HANDLE_T f;
    PFprintf( "*ELF SettingLight*  DATA = %d \n", (UINT8)u_atol( event->attachment));
    if (event->attachment != 0)
    {

		//PFprintf( "*ELF SettingLight*  DATA = %d \n", (UINT8)u_atol( event->attachment));
		
		switch (siItem)
		{
			case 1: // 
				
				u_utoa(event->attachment,bufR);
				
				//PFprintf( "*ELF SettingLight*  attachment = %d \n", (UINT8)strlen(bufR));
				SEEM_FDI_OUTSIDE_SEEM_ACCESS_write(0,0x017F,1,bufR,strlen(bufR)+1);
				
			break;
			case 2: // 
				
				//bufM=event->attachment;
				
				//PFprintf( "*ELF SettingLight*  attachment = %d \n", (UINT8)strlen(bufR));
				SEEM_FDI_OUTSIDE_SEEM_ACCESS_write(0,0x0117,1,(void*)event->attachment,(u_strlen(event->attachment)+1)*sizeof(WCHAR));
				
			break;
			
			case 3:
				S=1;
				u_utoa(event->attachment,bufR3);
				//AFW_CreateInternalQueuedEvAux(1616,0x65,0,0);
				AFW_CreateInternalQueuedEvAux(strtoul(bufR3,'\0',10),0x65,0,0);
				
				break;
				
			
        }
		
		
		
			
				
    }

	  if(siItem==3)
	  	{
	  		if(S==1){
    status = APP_UtilChangeState( HW_STATE_ANY, ev_st, app );
    HelloWorldExit(ev_st,app);
        }
        if(S==0)
        	status = APP_UtilChangeState( HW_STATE_MAIN, ev_st, app );
  }
    else
    	status = APP_UtilChangeState( HW_STATE_MAIN, ev_st, app );
	
    return status;

}


UINT32 EditOk( EVENT_STACK_T *ev_st,  void *app )
{
     UINT32                  status = 0;
     ADD_EVENT_DATA_T *ev_data;

     APP_HELLOWORLD_T           *papp = (APP_HELLOWORLD_T*) app;
     AFW_AddEvEvD(ev_st, EV_REQUEST_DATA,ev_data);
	 UIS_HandleEvent( papp->apt.dialog,  ev_st );
  //PFprintf( "*ELF SettingLight*  DATA = EditOk",papp->apt.dialog);
    PFprintf("*ELF SettingLight* EditOk:%x\n",papp->apt.dialog);

    return status;
}


UINT32 EditExit( EVENT_STACK_T *ev_st,  void *app )
{
    UINT32                  status = 0;
	APP_HELLOWORLD_T           *papp = (APP_HELLOWORLD_T*) app;
	 PFprintf("*ELF SettingLight* EditExit:%x\n",papp->apt.dialog);
	APP_UtilUISDialogDelete( &papp->apt.dialog );
    status = APP_UtilChangeState( HW_STATE_MAIN, ev_st, app ); // 
	
    return status;
}


UINT32 StateExit( EVENT_STACK_T *ev_st,  void *app,  EXIT_STATE_TYPE_T type )
{
	APP_HELLOWORLD_T           *papp = (APP_HELLOWORLD_T*) app;
	APP_UtilUISDialogDelete( &papp->apt.dialog );
	PFprintf("*ELF SettingLight* StateExit:%x\n",papp->apt.dialog);
	return RESULT_OK;
}

void BackupToFile()
{
        WCHAR* strFilePath = suAllocMem( 100, NULL );
        FILE_HANDLE_T hFile;
        UINT32 result;
        void* pAddrStart;
        UINT32 len;
        u_atou( "file://b/Elf/PDS.bin", strFilePath); //·
        if( DL_FsFFileExist( strFilePath ))
                DL_FsDeleteFile( strFilePath, 1 );
        hFile = DL_FsOpenFile( strFilePath, FILE_WRITE_EXIST_PLUS_MODE, 1 );
        pAddrStart = (void*) 0x10010000; // ʼַ
        len = 0x10000; //ݳ
        DL_FsWriteFile( pAddrStart, 1, len, hFile, &result);
        DL_FsCloseFile( hFile );
        suFreeMem( strFilePath );
        
}
void ToneDBKiller()
{

	WCHAR buf[64];
	
	
	DL_FsDeleteFile(u_atou("file://a/mobile/audio/MyToneDB.db", buf), 0 );
	DL_FsDeleteFile(u_atou("file://a/mobile/audio/TempToneDB.db", buf), 0 );
	}

UINT32 Timer( EVENT_STACK_T *ev_st,  void *app )
{
	if (((DL_TIMER_DATA_T*)(AFW_GetEv(ev_st)->attachment))->ID == 1) HAPI_WATCHDOG_soft_reset();
	 return RESULT_OK;
}		

UINT32 NoticeStateEnter( EVENT_STACK_T *ev_st,  void *app,  ENTER_STATE_TYPE_T type )
{
    APPLICATION_T           *papp = (APPLICATION_T*) app;
    SU_PORT_T               port = papp->port;
    CONTENT_T               content;
    UIS_DIALOG_T            dialog = 0;
	
	WCHAR msg[64];

	if(type!=ENTER_STATE_ENTER) return RESULT_OK;
    
    UIS_MakeContentFromString("MCq0", &content, u_atou (" ^_^\nIt is executed", msg)); //?? 
    
    dialog = UIS_CreateTransientNotice( &port, &content, NOTICE_TYPE_OK );
      
    if(dialog == 0) return RESULT_FAIL;

    papp->dialog = dialog;

    return RESULT_OK;
}


UINT32 ShortcutB( )
{
	UINT8 buf0157[14];
	UINT8 buf0002[0x44]; 
	UINT32 ii,k=0;
	WCHAR* strFilePath = suAllocMem( 100, NULL );
  FILE_HANDLE_T hFile;
  UINT32 result;

  
        
 SEEM_FDI_OUTSIDE_SEEM_ACCESS_read(0x0157,1,(void*)buf0157,14);
 
 
  PFprintf("*ELF k:%d\n",k);
 
   //PFprintf("*ELF l:%d\n",l);
   
        u_atou( "file://b/Elf/shortcutDB.bin", strFilePath); //·
        if( DL_FsFFileExist( strFilePath ))
                DL_FsDeleteFile( strFilePath, 1 );
        hFile = DL_FsOpenFile( strFilePath, FILE_WRITE_EXIST_PLUS_MODE, 1 );
        
       
        DL_FsWriteFile( (void*)buf0157,14, 1, hFile, &result);
        
        
          for (ii=0; ii < 0x63; ii++)
          {
          SEEM_FDI_OUTSIDE_SEEM_ACCESS_read(0x0002,ii+1,(void*)buf0002,0x44);	
        DL_FsWriteFile( (void*)buf0002,0x44, 1, hFile, &result);
         }
        DL_FsCloseFile( hFile );
        // PFprintf("*ELF b2:%d\n",k);
        suFreeMem( strFilePath );
        
  return 0;
}

UINT32 ShortcutR()
{   
	  UINT8 buf0157[14];
	UINT8 buf0002[0x44]; 
	  FILE_HANDLE_T hFile;
  UINT32 result,len,ge,ii;
		WCHAR* strFilePath = suAllocMem( 100, NULL );
		 u_atou( "file://b/Elf/shortcutDB.bin", strFilePath); 
		 
	if( DL_FsFFileExist( strFilePath ))
		{
			hFile = DL_FsOpenFile( strFilePath, FILE_READ_PLUS_MODE, 1 );
			len=DL_FsGetFileSize(hFile);
			DL_FsReadFile( (void*)buf0157,
                     14,
                     1,
                     hFile,
                     &result);
       SEEM_FDI_OUTSIDE_SEEM_ACCESS_write( 0,0x0157, 1,(void*)buf0157, 14); 
        ge=(len-14)/0x44;
        for (ii=0; ii < ge; ii++)
        {
        	DL_FsReadFile( (void*)buf0002,
                     0x44,
                     1,
                     hFile,
                     &result);
        	SEEM_FDI_OUTSIDE_SEEM_ACCESS_write( 0,0x0002,ii+1,(void*)buf0002, 0x44);
        }
                  
			 DL_FsCloseFile( hFile );
		}
		
		suFreeMem( strFilePath );	
		
	return 0;
}
UINT32 RSelectItem (EVENT_STACK_T *ev_st,  void *app )
{
     UINT32                  status;
	 EVENT_T     *event = AFW_GetEv(ev_st);
	
	UINT32 rsiItem = event->data.index;
   if(rsiItem==1)
   	{
   				 ShortcutB();
   				 status =APP_UtilChangeState( HW_STATE_NOTICE, ev_st, app );
   			}
   	if(rsiItem==2)
   	{	
   		ShortcutR();
    status =APP_UtilChangeState( HW_STATE_NOTICE, ev_st, app );
  }
	APP_ConsumeEv( ev_st, app );
    return RESULT_OK;

}

UINT32 RStaticlistStateEnter( EVENT_STACK_T *ev_st,  void *app,  ENTER_STATE_TYPE_T type )
{
        APP_HELLOWORLD_T           *papp = (APP_HELLOWORLD_T*) app;
		 RESOURCE_ID             CaptionEditor=Resources[RES_EDIT_CAPTION7];
		// RESOURCE_ID             CaptionEditor1=Resources[RES_EDIT_CAPTION5];
		LIST_ENTRY_T            *plist; // 
		 
		
		 
		
	
        
        
		switch (siItem)
		{
			
			
			case 7: // 
				plist = (LIST_ENTRY_T*) suAllocMem( sizeof(LIST_ENTRY_T)*2, NULL );
        plist[0].editable = FALSE;          
        plist[0].content.static_entry.unk6 = 1;
        plist[1].editable = FALSE;          
        plist[1].content.static_entry.unk6 = 1;
        
        
				UIS_MakeContentFromString( "Mq0", &(plist[0].content.static_entry.text),shortcut1);
				
        UIS_MakeContentFromString( "Mq0", &(plist[1].content.static_entry.text),shortcut2);
        
        
      
        
        
        
			break;
			
			
		}

       papp->apt.dialog = UIS_CreateStaticList( &papp->port,
                                                  0,
                                                  2,
                                                  0,
                                                  plist,
                                                  0,
                                                  2,
                                                  NULL,
                                                  CaptionEditor
                                                );  
    
     
                                                 
		if(papp->apt.dialog == 0)
            return RESULT_FAIL;

  suFreeMem(plist);
 
        return RESULT_OK;
}